/************************************************************************
*																		*
*	TESample.r															*
*																		*
*	This file contains the resources to be included in the TESample		*
*	application.														*
*																		*
*	Copyright  1988 Claris Corporation									*
*	All Rights Reserved													*
*																		*
************************************************************************/

#ifndef __TE_Sample_Res__
#define __TE_Sample_Res__

#include "systypes.r"
#include "types.r"

#include "TESample.h"		/* Contains necessary defines used in this file */


resource 'STR#' (25002, "PopUp Menu Names", purgeable) {
	{	/* array StringArray: 3 elements */
		/* [1] */
		"TESample",
		/* [2] */
		"TESample Stationery",
		/* [3] */
		"Text"
	}
};

resource 'STR#' (25003, "Claris  names", purgeable) {
	{	/* array StringArray: 1 elements */
		/* [1] */
		"Claris"
	}
};

resource 'STR#' (25004, "Claris XTND names", purgeable) {
	{	/* array StringArray: 2 elements */
		/* [1] */
		"Claris Translators",
		/* [2] */
		"Claris XTND System"
	}
};


resource 'vers' (1) {
	0x02, 0x00, release, 0x00, verUS,
	"2.00",
#ifdef qFINAL
	"2.00, Copyright  1989-1991 Apple Computer, Inc."
#else
	$$Shell("VERS_TAG")
#endif qFINAL
};

/* we use an MBAR resource to conveniently load all the menus */

resource 'MBAR' (rMenuBar, preload) {
	{ mApple, mFile, mEdit, mFont, mSize };		/* five menus */
};


resource 'MENU' (mApple, preload) {
	mApple, textMenuProc,
	0b1111111111111111111111111111101,	/* disable dashed line, enable About and DAs */
	enabled, apple,
	{
		"About TESample\311",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mFile, preload) {
	mFile, textMenuProc,
	0b0000000000000000000100000000000,	/* enable Quit only, program enables others */
	enabled, "File",
	{
		"New",
			noicon, "N", nomark, plain;
		"Open",
			noicon, "O", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Close",
			noicon, "W", nomark, plain;
		"Save",
			noicon, "S", nomark, plain;
		"Save As\311",
			noicon, nokey, nomark, plain;
		"Revert",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Page Setup\311",
			noicon, nokey, nomark, plain;
		"Print\311",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Quit",
			noicon, "Q", nomark, plain
	}
};

resource 'MENU' (mEdit, preload) {
	mEdit, textMenuProc,
	0b0000000000000000000000000000000,	/* disable everything, program does the enabling */
	enabled, "Edit",
	 {
		"Undo",
			noicon, "Z", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Cut",
			noicon, "X", nomark, plain;
		"Copy",
			noicon, "C", nomark, plain;
		"Paste",
			noicon, "V", nomark, plain;
		"Clear",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (mFont, preload) {
	mFont, textMenuProc,
	0,	/*  */
	disabled, "Font",
	{
	}
};

resource 'MENU' (mSize, preload) {
	mSize, textMenuProc,
	0,	/*  */
	disabled, "Size",
	{
		"PointSize",
			noicon, nokey, nomark, plain;
		"0",
			noicon, nokey, nomark, plain
	}
};

/* this ALRT and DITL are used as an About screen */

resource 'ALRT' (rAboutAlert, purgeable) {
	{40, 20, 198, 320}, rAboutAlert, {
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent;
		OK, visible, silent
	};
};

resource 'DITL' (rAboutAlert, purgeable) {
	{ /* array DITLarray: 5 elements */
		/* [1] */
		{130, 109, 150, 189},
		Button {
			enabled,
			"Thanks!"
		},
		/* [2] */
		{8, 10, 25, 322},
		StaticText {
			disabled,
			"XTND-Capable Styled TextEdit Application"
		},
		/* [3] */
		{29, 10, 63, 311},
		StaticText {
			disabled,
			"Copyright  1989-1991 Apple Computer\n"
			"& Claris Corporation"
		},
		/* [4] */
		{70, 10, 86, 138},
		StaticText {
			disabled,
			"Brought to you by:"
		},
		/* [5] */
		{89, 10, 123, 281},
		StaticText {
			disabled,
			"Macintosh Developer Technical Support\n"
			"& Claris Corporation"
		}
	}
};


/* this ALRT and DITL are used as an error screen */

resource 'ALRT' (rUserAlert, purgeable) {
	{40, 20, 150, 260},
	rUserAlert,
	{ /* array: 4 elements */
		/* [1] */
		OK, visible, silent,
		/* [2] */
		OK, visible, silent,
		/* [3] */
		OK, visible, silent,
		/* [4] */
		OK, visible, silent
	}
};


resource 'DITL' (rUserAlert, purgeable) {
	{ /* array DITLarray: 3 elements */
		/* [1] */
		{85, 86, 105, 166},
		Button {
			enabled,
			"Sorry"
		},
		/* [2] */
		{10, 60, 75, 228},
		StaticText {
			disabled,
			"Error. ^0.\n^1"
		},
		/* [3] */
		{8, 8, 40, 40},
		Icon {
			disabled,
			2
		}
	}
};


resource 'WIND' (rDocWindow, preload, purgeable) {
	{64, 60, 314, 460},
	zoomDocProc, invisible, goAway, 0x0, "Untitled"
};


resource 'CNTL' (rVScroll, preload, purgeable) {
	{-1, 385, 236, 401},
	0, visible, 0, 0, scrollBarProc, 0, ""
};


resource 'CNTL' (rHScroll, preload, purgeable) {
	{235, -1, 251, 386},
	0, visible, 0, 0, scrollBarProc, 0, ""
};

resource 'STR#' (kErrStrings, purgeable) {
	{
	"You must run on 512Ke or later";
	"Application Memory Size is too small";
	"Not enough memory to run TESample";
	"Not enough memory to do Cut";
	"Cannot do Cut";
	"Cannot do Copy";
	"Cannot exceed 32,000 characters with Paste";
	"Not enough memory to do Paste";
	"Cannot create window";
	"Cannot exceed 32,000 characters";
	"Cannot do Paste";
	"Could not open the correct translator";
	"Could not read in the correct translator";
	"Error opening resource fork of document";
	"Error reading resources from document";
	"Error opening document";
	"Error initializing translator";
	"Error deleting previous file";
	"Could not create file";
	"Error opening file"
	}
};

/* here is the quintessential MultiFinder friendliness device, the SIZE resource */

resource 'SIZE' (-1) {
	dontSaveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,				/* we can background; we don't currently, but our sleep value */
								/* guarantees we don't hog the Mac while we are in the background */
	multiFinderAware,			/* this says we do our own activate/deactivate; don't fake us out */
	backgroundAndForeground,	/* this is definitely not a background-only application! */
	dontGetFrontClicks,			/* change this is if you want "do first click" behavior like the Finder */
	ignoreChildDiedEvents,		/* essentially, I'm not a debugger (sub-launching) */
	not32BitCompatible,			/* this app should not be run in 32-bit address space */
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	kPrefSize * 1024,
	kMinSize * 1024
};


type 'XTND' as 'STR ';


resource 'XTND' (0) {
	"XTND-Capable Styled TextEdit Application"
};


resource 'BNDL' (128) {
	'XTND',
	0,
	{
		'ICN#',
		{
			0, 128
		},
		'FREF',
		{
			0, 128
		}
	}
};


resource 'FREF' (128) {
	'APPL',
	0,
	""
};


resource 'ICN#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"0430 4000 0A50 A000 0B91 1002 0822 0803"
		$"1224 0405 2028 7FF9 4010 2011 8000 1011"
		$"8802 2012 7405 4014 0208 8814 0410 4418"
		$"0820 2214 1044 1052 1882 08B1 0D11 1112"
		$"0A08 2204 0844 4408 0820 8810 0811 1020"
		$"0802 A040 0804 4080 0808 0100 0804 0200"
		$"0FFE 0400 0002 0800 0001 1000 0000 A000"
		$"0000 40",
		/* [2] */
		$"0430 4000 0E70 E000 0FF1 F002 0FE3 F803"
		$"1FE7 FC07 3FEF FFFF 7FFF FFFF FFFF FFFF"
		$"FFFF FFFE 7FFF FFFC 01FF FFFC 03FF FFF8"
		$"07FF FFFC 0FFF FFFE 1FFF FFFF 0FFF FFFE"
		$"0FFF FFFC 0FFF FFF8 0FFF FFF0 0FFF FFE0"
		$"0FFF FFC0 0FFF FF80 0FFF FF00 0FFF FE00"
		$"0FFF FC00 0003 F800 0001 F000 0000 E000"
		$"0000 40"
	}
};

#endif