/************************************************************************
*																		*
*	MacWrite.h															*
*																		*
*	Header for the MacWrite v5.0 import and export translators.			*
*																		*
*	Copyright  1988, 89, 90, 91 Claris Corporation						*
*	All Rights Reserved													*
*																		*
*	Author: Richard Scorer												*
*	Date:   13 April, 1988												*
*																		*
************************************************************************/

#ifndef _H_MacWriteHdr_
#define _H_MacWriteHdr_


#define	AFooter		0
#define	AHeader		1
#define	TheMainDoc	2


typedef struct MacWriteWindow {		/* MacWrite's Window variables */
	short	selStartPar;
	short	selStartCh;
	short	selEndPar;
	short	selEndCh;
	short	vertOffSet;
	short	need2Redraw;
	long	infoAryPos;
	short	infoAryLength;
	long	lineHeightAryPos;
	short	lineHeightAryLength;
	long	pageNumPos;
	long	datePos;
	long	timePos;
	long	unused3639;
	char	ovalRedraw;
	char	lastOval;
	short	activeStyle;
	short	activeFont;
} MacWriteWindow;


typedef struct MWHeader {	/* MacWrite 5.0 header */
	short	versionNo;
	short	mainPars;
	short	headerPars;
	short	footerPars;
	char	titlePage;
	char	unused9;
	char	scrapDisplay;
	char	footerDisplay;
	char	headerDisplay;
	char	rulersHidden;
	short	activeDoc;
	short	startPageNum;
	long	freeListPos;
	short	freeListLen;
	short	freeListAlloc;
	char	unused2639[14];
	TPrint	printRecord;
	MacWriteWindow	window[3];
} MacWriteHeader, **MacWriteHdrHandle;


typedef	struct InfoStruct {	/* Information array */
	short	paraHeight;
	short	paraPagePosn;
	long	paraHndl;
	struct {
		unsigned	long	justCode:8;
		unsigned	long	paraFilePosn:24;
	} Status;				/* Offset into file */
	short	paraLen;		/* Length of paragraph data in bytes.  includes format runs... */
	short	paraFmt;
} InfoStruct;


typedef struct FreeBlock { /* Free list array */
	long	filePos;
	long	blockSize;
} FreeBlock;


typedef struct FormatRun { /* What it say huh ? */
	short	firstChar;
	char	pointSize;
	char	styleSetting;
	short	fontNo;
} FormatRun;


typedef struct RulerParagraph { /* A ruler paragraph definition */
	short	leftMargin;		/* Horiz co-ordinates.  1/80" from left - starting at 1"*/
	short	rightMargin;	/* From left side of screen to right margin (1/80") */
	char	justification;	/* 0,1,2 or 3 */
	char	numTabs;		/* From 1-10 */
	short	lineSpacing;
	short	lineIndent;		/* From left of screen */
	short	tabArray[10];	/* #pixels btwn left side & tab */
	long	unused3033;
} RulerParagraph;


typedef struct PictureParagraph { /* A picture paragraph definition */
	Rect	pictureSize;	/* size of the picture */
	Picture	thePicture;		/* a standard QuickDraw Picture */
} PictureParagraph;


typedef struct MWFormat { /* A MacWrite format */
	short			charPos;	/* first character affected by this format */
	unsigned char	pointSize;	/* point size */
	unsigned char	style;		/* standard style byte */
	short			fontNumber;	/* font number */
} MWFormat;


typedef struct LineHeightArray
{
	char	heightInfo[6];
} LineHeightArray;

#endif