/************************************************************************
*																		*
*	MacWriteExport.h													*
*																		*
*	Header for the MacWrite v5.0 export translator.						*
*																		*
*	Copyright  1988, 89, 90, 91 Claris Corporation						*
*	All Rights Reserved													*
*																		*
*	Author: Richard Scorer												*
*	Date:   13 April, 1988												*
*																		*
************************************************************************/

#ifndef _H_MWExportHdr_
#define _H_MWExportHdr_


/* MacWrite Paragraph */
typedef struct {
	Boolean	ruler;
	long	filePos, pagePos;
	short	length, height;
	short	justification;
} ParagraphInfo,*ParagraphPtr,**ParagraphHandle;


/* MacWrite Formats */
typedef struct {
	short	filePos;
	Byte	pointSize, styleSet;
	short	fontNum;
} FormatInfo,*FormatPtr,**FormatHandle;


/* MacWrite Ruler */
typedef struct {
	short	left, right;
	Byte	justification, numTabs;
	short	spacing, indentation, theTabs[10];
	long	dummy;
} RulerInfo,*RulerPtr,**RulerHandle;


/* MacWrite LineHeights */
typedef struct {
	short	nBytes;		/* Number of bytes for this line height entry */
	short	lHeight;	/* Line height*/
} LineInfo, *LinePtr, **LineHandle;


/* box types used for header, footers and footnotes */
#define kNone				0
#define kHeader				1
#define kFooter				2
#define kFootnote			3



/* types of pages for headers/footers */
#define EveryPage			1
#define LeftPage			2
#define RightPage			4
#define LeftAndRightPage	6


#define	ISSPECIALCHAR(z)	(((z)>=pageNumber&&(z)<= footnoteChar)||((z)>= shortDateChar&&(z)<=timeChar))

#endif